#include "stdio.h"
#include "string.h"

const int N = 8;
const int L = 3;

int ss = 0;
int ff = 0;

bool g[N][N];
bool h[N];
int startingVertex;

#define EXTRA_OPTIMIZATION 1

bool dfs(int v, int t) {
	if (t == 0) {
		if (h[v] && v != startingVertex) {
			return false;
		}
		h[v] = 1;
		return true;
	}
	for (int i = 0; i < N; ++i) {
		if (g[v][i]) {
			if (!dfs(i, t - 1)) {
				return false;
			}
		}
	}
	return true;
}

int checkVertex(int v) {
	startingVertex = v;
	memset(h, 0, sizeof(h));
	if (!dfs(v, L)) {
		return false;
	}
	for (int i = 0; i < N; ++i) {
		if (!h[i] && i != v) {
			return false;
		}
	}
	return true;
}

int checkGraph() {
	for (int i = 0; i < N; ++i) {
		if (!checkVertex(i)) {
			return false;
		}
	}
	return true;
}

bool generateGraphs(int i, int j, int numEdges) {
	if (i == N) {
		if (numEdges < N) {
			return false;
		}
		return checkGraph();
	}
	if (i == j) {
		return generateGraphs(i + 1, 0, numEdges);
	}
#if EXTRA_OPTIMIZATION
	if (i > 3 && numEdges * 4 >= N * (i + 1) && numEdges % 2 == 0) {
		memset(g[i] + j, 0, N * (N - i) - j);
		for (int k = 0; k <= i; ++k) {
			startingVertex = k;
			memset(h, 0, sizeof(h));
			if (!dfs(k, L)) {
				++ss;
				return false;
			}
		}
		++ff;
	}
#endif
	g[i][j] = false;
	g[j][i] = false;
	if (generateGraphs(i, j + 1, numEdges))
		return true;
	g[i][j] = true;
	g[j][i] = true;
	return generateGraphs(i, j + 1, numEdges + 1);
}


int main() {
	const bool isThereSuchGraph = generateGraphs(0, 0, 0);
	if (isThereSuchGraph) {
		printf("There is a counterexample; the adjacency matrix of the graph is\n");
		for (int i = 0; i < N; ++i) {
			for (int j = 0; j < N; ++j) {
				printf("%d ", (int)g[i][j]);
			}
			printf("\n");
		}
	}
	else {
		printf("There is no counterexample.\n");
	}
	return 0;
}
